import { getAccountIdForRequest } from "@/src/services/loginService";
import { getInventory, addEquipment, occupySlot, productCategoryToInventoryBin } from "@/src/services/inventoryService";
import { RequestHandler } from "express";
import { modularWeaponTypes } from "@/src/helpers/modularWeaponHelper";

export const addModularEquipmentController: RequestHandler = async (req, res) => {
    const accountId = await getAccountIdForRequest(req);
    const request = req.body as IAddModularEquipmentRequest;
    const inventory = await getInventory(accountId);
    const category = modularWeaponTypes[request.ItemType];
    addEquipment(inventory, category, request.ItemType, request.ModularParts);
    occupySlot(inventory, productCategoryToInventoryBin(category)!, true);
    await inventory.save();
    res.end();
};

interface IAddModularEquipmentRequest {
    ItemType: string;
    ModularParts: string[];
}
